//+------------------------------------------------------------------+
//|                                              ea_for_williams.mq4 |
//|                                                 han yi, williams |
//|                     hetachy@hotmail.com, yemiojes@fastermail.com |
//+------------------------------------------------------------------+



///////////////////////////strategities////////////////////////////////////////////
// The EA will based on combination of 2 Exponential Moving Averages(close) with Simple Stochastic indicator (close).
// The EMA parameters are - 1 & 3.(close)
// The parameters for Simple Stochastics are 5,3,3.(close)
// The EA will place buy order when EMA 1 is greater than EMA 3,and the straight line is above the dotted line in Simple Stochastic indicator.
// It will place sell order immediately EMA 3 crosses above EMA 1,and the dotted line crosses above the straight line in Simple Stochastic Indicator.
// As soon as there is a buy signal ,every sell order already opened must be closed.
// And as soon as there is a sell signal every opened buy order must be closed.
// It will have a take profit of 20 ,and a stop loss of 15.
// Most importantly, it will have Magic number to enable it work on multiple pairs at the same time.
// This strategy worked very well on 5 min charts.
///////////////////////////////////////////////////////////////////////////////////////////////  

#property copyright "han yi, williams"
#property link      "hetachy@hotmail.com, yemiojes@fastermail.com"

//---- input parameters
extern double    Lots = 0.1;
extern int       MagicNumber=11111;
extern int       TP=20;
extern int       SL=15;
extern int       Slippage = 3;
extern int       ema1_period=1;          // slow ema period
extern int       ema2_period=3;          // fast ema period
extern int       TS = 50;       // trailing stop
extern bool      time_filter=false;     


int time1 = 7;       // time filter start, you may set according to your time zone
int time2 = 18;      // time filter end   
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
       int cnt, order_num;
	    double ema1_last1, ema1_last2, ema2_last1, ema2_last2;
       double sto_main, sto_signal; 
       double MacdPrevious, SignalPrevious;
       double CCI1;
       int spread = Ask - Bid;   // to check spread for each entry
       bool buy_can = false;
       bool sell_can = false;
       
       ema1_last1 = iMA(NULL,0,ema1_period,0,MODE_EMA,PRICE_CLOSE,1);
       ema1_last2 = iMA(NULL,0,ema1_period,0,MODE_EMA,PRICE_CLOSE,2);
       ema2_last1 = iMA(NULL,0,ema2_period,0,MODE_EMA,PRICE_CLOSE,1);
       ema2_last2 = iMA(NULL,0,ema2_period,0,MODE_EMA,PRICE_CLOSE,2);
       
       sto_main = iStochastic(NULL, 0, 5, 3, 3, MODE_MAIN, 1, MODE_SMA, 1); 
       sto_signal = iStochastic(NULL, 0, 5, 3, 3, MODE_SIGNAL, 1, MODE_SMA, 1); 
       
       MacdPrevious=iMACD(NULL,0,12,26,9,PRICE_TYPICAL,MODE_MAIN,1);
       SignalPrevious=iMACD(NULL,0,12,26,9,PRICE_TYPICAL,MODE_SIGNAL,1);
       
       CCI1 = iCCI(NULL,0,50,PRICE_TYPICAL,0);
       
       /////////////////////////Judge the entry signal/////////////////////////////////////////////////
       if ( Volume[0] <= 1)  // only new bar check the signal
	   {
	       if (CCI1 > 0 && MacdPrevious > SignalPrevious)
                  buy_can = true;
	       else
		          buy_can = false;     // the buy signal only occurs when cross happen


           if (CCI1 < 0 && MacdPrevious < SignalPrevious)
                  sell_can = true;
	       else
		          sell_can = false;     // the sell signal only occurs when cross happen
	   }
       ///////////////////////////////////////////////////////////////////////////////////////////////



	   ///////////////////////Close existing order when reverse trend signal occurs ////////////
	   //////////////////////////////////and calculate order_num for this ea////////////////////
	   order_num = 0;        // the number of order of this ea             
	   for(cnt = 0; cnt < OrdersTotal(); cnt++)
       {
             OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
			 if( OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
			 {
				 order_num++;
				 if ( OrderType() == OP_BUY && sell_can)
				 {
					 OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Red);
					 order_num--;
				 } 

				 if ( OrderType() == OP_SELL && buy_can)
				 {
					 OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
					 order_num--;
				 } 
			 }
	   }
	   /////////////////////////////////////////////////////////////////////////////////////////
	   
	    ///////////////////////////Trailing stop////////////////////////////////////////////////
      for (cnt = OrdersTotal(); cnt >= 0; cnt--)
      {
        OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
        if( OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        {
           if (OrderType() == OP_SELL && TS > 0 )
           {
             if (OrderOpenPrice() - Ask >= TS * Point && OrderStopLoss() > Ask + Point * TS )
             OrderModify(OrderTicket(),OrderOpenPrice(),Ask + Point * TS,OrderTakeProfit(),0,Purple);
           }
           
           if (OrderType() == OP_BUY && TS > 0 )
           {
             if (Bid - OrderOpenPrice()  >= TS * Point && OrderStopLoss() < Bid - Point * TS )
             OrderModify(OrderTicket(),OrderOpenPrice(),Bid - Point * TS,OrderTakeProfit(),0,Purple);
           }
         }
       }  
      ///////////////////////////////////////////////////////////////////////////////////////////
      


	   //////////////////////////open order/////////////////////////////////////////////////////
	   if ( time_filter == false || ( TimeHour(TimeCurrent())>= time1 && TimeHour(TimeCurrent())<= time2))
	   if ( order_num < 1 )   // only 1 order allowed for this ea
	   {
		   if (buy_can)
		   {
			   OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask - spread - SL*Point, Ask + TP*Point,"",MagicNumber,0,Blue);
			   buy_can = false; // avoid entering the trade twice in the sam bar
		   }

		   if (sell_can)
		   {
			   OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid + spread + SL*Point, Bid - TP*Point,"",MagicNumber,0,Blue);
			   sell_can = false; // avoid entering the trade twice in the sam bar
		   }
	   }
	   ////////////////////////////////////////////////////////////////////////////////////////////////
//----
   return(0);
  }
//+------------------------------------------------------------------+